.report:
  stage: Report
  image: alpine:latest
  cache: {}
  dependencies:
    - 'Unit'

include:
  - local: '.gitlab/ci/report/code-quality.yaml'

Code Coverage:
  extends: .report
  needs:
    - 'Unit'
  coverage: '/^Coverage total:\s*([\d\.]+)%/'
  script:
    - 'apk add --no-cache curl jq'
    - 'total=$(cat ./coverage/coverage-summary.json | ./.gitlab/ci/scripts/calculate_coverage.sh) || /bin/true'
    - 'echo "Coverage total: ${total:-parse error}%"'
  artifacts:
    reports:
      cobertura: coverage/cobertura-coverage.xml
    when: always

pages:
  extends: .report
  needs:
    - 'Unit'
  script:
    - 'apk add --no-cache curl jq'
    - './.gitlab/ci/scripts/get_pages_archive.sh'
    - '[[ -d "./public/${CI_COMMIT_BRANCH}" ]] || mkdir "./public/${CI_COMMIT_BRANCH}"'
    - '[[ -d "./public/${CI_COMMIT_BRANCH}/coverage" ]] && rm -r "./public/${CI_COMMIT_BRANCH}/coverage"'
    - 'cp -r ./coverage "./public/${CI_COMMIT_BRANCH}/coverage"'
  artifacts:
    # Lint Error: jobs:pages:artifacts:expose_as can contain only letters, digits, '-', '_' and spaces
    expose_as: 'Pages Archive'
    name: '$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA-pages_archive'
    paths:
      - './public/'
